//------------------------------------------------------------------------------
// Lamp : Open source game middleware
// Copyright (C) 2004  Junpei Ohtani ( Email : junpee@users.sourceforge.jp )
//
// This library is free software; you can redistribute it and/or
// modify it under the terms of the GNU Lesser General Public
// License as published by the Free Software Foundation; either
// version 2.1 of the License, or (at your option) any later version.
//
// This library is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
// Lesser General Public License for more details.
//
// You should have received a copy of the GNU Lesser General Public
// License along with this library; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
//------------------------------------------------------------------------------

/** @file
 * EBhENG[^wb_
 * @author Junpee
 */

#ifndef WINDOW_CREATOR_H_
#define WINDOW_CREATOR_H_

namespace Lamp{

//------------------------------------------------------------------------------
/**
 * EBhENG[^
 */
class WindowCreator{
public:
	/**
	 * EBhE쐬p[^
	 */
	class CreateParameter{
	public:
		/**
		 * RXgN^
		 */
		CreateParameter();

		/// EBhE
		String windowName_;
		/// CX^Xnh
		HINSTANCE instanceHandle_;
		/// EBhEvV[W
		WNDPROC windowProcedure_;
		/// EBhEX^C
		u_int windowStyle_;
		/// 쐬EBhE̕
		int createWidth_;
		/// 쐬EBhE̍
		int createHeight_;
		/// ACRnh
		HICON iconHandle_;
		/// ACRnh
		HICON smallIconHandle_;
		/// J[\nh
		HCURSOR cursorHandle_;
	};

	/**
	 * EBhE̍쐬
	 * @param parameter EBhE쐬p[^
	 * @return EBhEnh
	 */
	static HWND create(const CreateParameter& parameter);

	/**
	 * EBhE̔j
	 * @param windowHandle jEBhẼnh
	 */
	static void destroy(HWND windowHandle);

private:
	// RXgN^̉B
	WindowCreator();

};

//------------------------------------------------------------------------------
} // End of namespace Lamp
#endif // End of WINDOW_CREATOR_H_
//------------------------------------------------------------------------------

