//------------------------------------------------------------------------------
// Lamp : Open source game middleware
// Copyright (C) 2004  Junpei Ohtani ( Email : junpee@users.sourceforge.jp )
//
// This library is free software; you can redistribute it and/or
// modify it under the terms of the GNU Lesser General Public
// License as published by the Free Software Foundation; either
// version 2.1 of the License, or (at your option) any later version.
//
// This library is distributed in the hope that it will be useful,
// but WITHOUT ANY WARRANTY; without even the implied warranty of
// MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
// Lesser General Public License for more details.
//
// You should have received a copy of the GNU Lesser General Public
// License along with this library; if not, write to the Free Software
// Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA
//------------------------------------------------------------------------------

/** @file
 * MayaDAG[eBeBwb_
 * @author Junpee
 */

#ifndef MAYA_DAG_UTILITY_H_
#define MAYA_DAG_UTILITY_H_

namespace LampForMaya{

//------------------------------------------------------------------------------
/**
 * MayaDAG[eBeB
 */
class MayaDAGUtility{
public:
	/**
	 * O̎擾
	 * @param node DAGm[h
	 * @return O
	 */
	static String getName(const MObject& node);

	/**
	 * O̎擾
	 * @param dagPath DAGpX
	 * @return O
	 */
	static String getName(const MDagPath& dagPath);

	/**
	 * tpX̎擾
	 * @param node DAGm[h
	 * @return tpX
	 */
	static String getFullPath(const MObject& node);

	/**
	 * tpX̎擾
	 * @param dagPath DAGpX
	 * @return tpX
	 */
	static String getFullPath(const MDagPath& dagPath);

	/**
	 * vO̎擾
	 * @param node fByfVm[h
	 * @param plugName vO
	 * @return vO
	 */
	static MPlug getPlug(const MObject& node, const String& plugName);

	/**
	 * vO̎擾
	 * @param dagPath DAGpX
	 * @param plugName vO
	 * @return vO
	 */
	static MPlug getPlug(const MDagPath& dagPath, const String& plugName);

private:
	// RXgN^̉B
	MayaDAGUtility();

};

//------------------------------------------------------------------------------
} // End of namespace LampForMaya
#endif // End of MAYA_DAG_UTILITY_H_
//------------------------------------------------------------------------------
